#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="75.000000" y="221.000000">
      <Parameter name="LENGTH" type="int" value="4096" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="int" value="512" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="44100" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="DOWHILE" type="int" value="" description=""/>
    </Node>
    <NetOutput name="TEMPO" node="node_MAIN_LOOP_1" terminal="TEMPO" object_type="any" description="No description available"/>
  </Network>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_MultiFFT_1" type="MultiFFT" x="-139.000000" y="351.000000">
      <Parameter name="LENGTH" type="int" value="4096" description="The length of FFT."/>
      <Parameter name="WINDOW" type="string" value="HAMMING" description="A window function for FFT. WINDOW should be &quot;CONJ&quot;."/>
      <Parameter name="WINDOW_LENGTH" type="int" value="4096" description="The length of the window."/>
    </Node>
    <Node name="node_AudioStreamFromMic_1" type="AudioStreamFromMic" x="-386.000000" y="297.000000">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="CHANNEL_COUNT" type="int" value="2" description="The number of channels."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="Sampling rate (Hz) [default: 16000]."/>
      <Parameter name="DEVICETYPE" type="string" value="ALSA" description="Device type (ASIO, ALSA, RASP, or WS) [default: WS]."/>
      <Parameter name="GAIN" type="string" value="0dB" description="capture gain (dB)  [default: 0dB]."/>
      <Parameter name="DEVICE" type="string" value="plughw:0,0" description="Device name or IP address [default: 127.0.0.1]"/>
    </Node>
    <Node name="node_BeatTracker_1" type="BeatTracker" x="66.000000" y="297.000000">
      <Parameter name="RELIABILITY-THRESHOLD" type="float" value="0.1" description="The threshold for the beat detection."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="subnet_param" value="SAMPLING_RATE" description="sampling rate of sound data."/>
      <Parameter name="MAX_BPM" type="int" value="120" description="Maximum BPM."/>
      <Parameter name="MIN_BPM" type="int" value="60" description="Minimum BPM."/>
      <Parameter name="VECTOR_FLAG" type="bool" value="false" description="Output vectors or not."/>
      <Parameter name="LOG_FLAG" type="bool" value="false" description="Log or not."/>
    </Node>
    <Link from="node_MultiFFT_1" output="OUTPUT" to="node_BeatTracker_1" input="FFTAUDIO"/>
    <Link from="node_AudioStreamFromMic_1" output="AUDIO" to="node_BeatTracker_1" input="AUDIO"/>
    <Link from="node_AudioStreamFromMic_1" output="AUDIO" to="node_MultiFFT_1" input="INPUT"/>
    <NetCondition name="CONDITION" node="node_AudioStreamFromMic_1" terminal="NOT_EOF"/>
    <NetOutput name="TEMPO" node="node_BeatTracker_1" terminal="TEMPO" object_type="float" description="beat tempo"/>
  </Network>
</Document>
